function addOption(widget, optionKey, optionType, optionName, optionHint, optionData){
  widget["options"    ].push(optionKey);
  widget["optionstype"].push(optionType);
  widget["optionsname"].push(optionName);
  widget["optionshint"].push(optionHint);
  widget["optionsdata"].push(optionData);
}

function line_widgetlist()
{
  var widgets = {
    "line":
    {
      "offsetx":-80,"offsety":-165,"width":160,"height":330,
      "menu":"Widgets",
      "options":[],
      "optionstype":[],
      "optionsname":[],
      "optionshint":[],
      "optionsdata":[]
    }
  }
  var lineType = [
        [0,   _Tr("LEFT -> RIGHT")],
        [1,    "RIGHT -> LEFT"],
        [2,    "TOP -> BOTTOM"],
        [3,    "BOTTOM -> TOP"],
        [4,    "UPPER LEFT -> BOTTOM RIGHT"],
        [5,    "BOTTOM RIGHT -> UPPER LEFT"],
		[6,    "UPPER RIGHT -> BOTTOM LEFT"],
        [7,    "BOTTOM LEFT -> UPPER RIGHT"]
    ];
	
	var animationType = [
		[0,   _Tr("None")],
        [1,    "Animate TRUE"],
		[2,    "Animate FALSE"]
	];
	
	addOption(widgets["line"], "feedid"			, "feedid"			, _Tr("Feed")			, _Tr("feed value")		, []);
	addOption(widgets["line"], "colour_true"	, "colour_picker"	, _Tr("Colour TRUE")	, _Tr("")				, []);
	addOption(widgets["line"], "colour_false"	, "colour_picker"	, _Tr("Colour FALSE")	, _Tr("")				, []);
	addOption(widgets["line"], "linetype"		, "dropbox"			, _Tr("Line Type")		, _Tr("")				, lineType);
	addOption(widgets["line"], "linewidth"		, "value"			, _Tr("Line Width")		, _Tr("")				, []);
	
	addOption(widgets["line"], "animationtype"	, "dropbox"			, _Tr("Animation Type")	, _Tr("")				, animationType);
	addOption(widgets["line"], "colour_symbol"	, "colour_picker"	, _Tr("Symbol Color")	, _Tr("")				, []);
	return widgets;
}

function line_draw()
{
  $(".line").each(function(index)
  {
	var feedid = $(this).attr("feedid");
    if (assocfeed[feedid]!=undefined) feedid = assocfeed[feedid]; // convert tag:name to feedid
    if (associd[feedid] === undefined) { console.log("Review config for feed id of " + $(this).attr("class")); return; }
    var val = associd[feedid]["value"] * 1;
	
	var id = "can-"+$(this).attr("id");
	var ctx = widgetcanvas[id];
	var x=0;
	var y=0;
	var width=$(this).width();
	var height=$(this).height();
	var lineWidth = parseInt($(this).attr("linewidth") || "1");
	var lineType = parseInt($(this).attr("linetype") || "0");
	var animationType = parseInt($(this).attr("animationtype") || "0");
	
	var colourTrue = $(this).attr("colour_true") || "000";
	if (colourTrue.indexOf("#") === -1) {colourTrue = "#" + colourTrue;} 
	
	var colourFalse = $(this).attr("colour_false") || "000";
	if (colourFalse.indexOf("#") === -1) {colourFalse = "#" + colourFalse;} 
	
	var colourSymbol = $(this).attr("colour_symbol") || "FFF";
	if (colourSymbol.indexOf("#") === -1) {colourSymbol = "#" + colourSymbol;} 
	
	
	
	var offset = lineWidth / 2;
	
	ctx.clearRect(0,0,width,height);
	
	ctx.lineWidth = lineWidth;
	
	var startX = 0, startY = 0, endX = 0, endY = 0;
	
	switch(lineType)
	{
		case 0: // LEFT -> RIGHT
			startX = offset; startY = height / 2; endX = width - offset; endY = height / 2;
			break;
		case 1: // RIGHT -> LEFT
			startX = width - offset; startY = height / 2; endX = offset; endY = height / 2;
			break;
		case 2: // TOP -> BOTTOM
			startX = width / 2; startY = offset; endX = width / 2; endY = height - offset;
			break;
		case 3: // BOTTOM -> TOP
			startX = width / 2; startY = height - offset; endX = width / 2; endY = offset;
			break;
		case 4: // UPPER LEFT -> BOTTOM RIGHT
			startX = offset; startY = offset; endX = width - offset; endY = height - offset;
			break;
		case 5: // BOTTOM RIGHT -> UPPER LEFT
			startX = width - offset; startY = height - offset; endX = offset; endY = offset;
			break;
		case 6: // UPPER RIGHT -> BOTTOM LEFT
			startX = width - offset; startY = offset; endX = offset; endY = height - offset;
			break;
		case 7: // BOTTOM LEFT -> UPPER RIGHT
			startX = offset; startY = height - offset; endX = width - offset; endY = offset;
			break;
	}
	
	ctx.beginPath();
	ctx.moveTo(startX, startY);
	ctx.lineTo(endX, endY);
	
	if(val > 0)
	{
		ctx.strokeStyle = colourTrue;
	}
	else
	{
		ctx.strokeStyle = colourFalse;
	}
	
	ctx.lineCap = 'round';
	ctx.stroke();
	
	/*
		var animationType = [
		[0,   _Tr("None")],
        [1,    "When TRUE"],
		[2,    "When FALSE"]
	];
	*/
	var isAnimationEnabled = false;
	switch(animationType)
	{
		case 1: // When TRUE
			if(val > 0)
				isAnimationEnabled = true;
			break;
		case 2: // When FALSE
			if(val <= 0)
				isAnimationEnabled = true;
			break;
	}
	
	if(isAnimationEnabled)
	{
		var step = ((new Date().getTime() / 1000) % 1) / 1;
		var stepX = startX + ((endX - startX) * step);
		var stepY = startY + ((endY - startY) * step);
		
		ctx.lineWidth = lineWidth;
		ctx.beginPath();
		ctx.moveTo(stepX, stepY);
		ctx.lineTo(stepX +1, stepY);
		ctx.strokeStyle = colourSymbol;
		ctx.stroke();
	}
	
	
    /*ctx.strokeStyle = "#fff";
    ctx.lineWidth = 8;

    ctx.fillStyle = get_color(cylTop,temptype);
    ctx.beginPath();
    ctx.arc(midx,topPos,cylWidth/2,Math.PI,0,false);
    ctx.closePath();
    ctx.fill();*/
    /*var feedid1 = $(this).attr("topfeedid");
    if (assocfeed[feedid1]!=undefined) feedid1 = assocfeed[feedid1]; // convert tag:name to feedid
    var feedid2 = $(this).attr("botfeedid");
    if (assocfeed[feedid2]!=undefined) feedid2 = assocfeed[feedid2]; // convert tag:name to feedid
    
    if ((associd[feedid1] === undefined) || (associd[feedid2] === undefined)) { console.log("Review config for feed id of " + $(this).attr("class")); return; }
    var cylTop = associd[feedid1]["value"]*1;
    var cylBot = associd[feedid2]["value"]*1;
    var unitend = $(this).attr("unitend") || "0";
    var temptype= $(this).attr("temptype") || "0";
    var decimals = $(this).attr("decimals") || "-1";

    var id = "can-"+$(this).attr("id");
    drawLine(widgetcanvas[id],cylBot,cylTop,$(this).width(),$(this).height(),temptype,unitend,decimals);*/
  });
}

function line_init()
{
  setup_widget_canvas("line");
}

function line_slowupdate()
{
  line_draw();
}

function line_fastupdate()
{
  line_draw();
}